import { LazyExoticComponent } from 'react';
import { EnvConfig } from '@Env/types';
import { ModuleKey } from '@Models/Redux/User/types';

export { ModuleKey };

export interface RouteItem {
  name: string;
  route: string;
  lang?: string;
  component: LazyExoticComponent;
  subRoute: RouteItem[];
  exact: boolean;
  avatar: string;
  avatarActive: string;
  permissions?: ModuleKey[];
  openNewWindow?: boolean;
  openNewWindowKey?: (keyof EnvConfig)[];
}

export interface RouteObject {
  [key: string]: RouteItem[];
}
