import { useMemo } from 'react';
import I18n from '@Models/Core/I18n';
import useMappedState from './useMappedState';

export interface UseLang {
  i18n: I18n;
}

/**
 * 描述 : 取得 翻譯檔 的 Class Instance
 */

export default function useLang(): UseLang {
  const storeGlobal = useMappedState((state) => state.global);
  return useMemo(() => ({ i18n: storeGlobal.globalI18n }), [storeGlobal.globalLang]);
}
