import {
 Store, createStore as reduxCreateStore, combineReducers, applyMiddleware,
} from 'redux';
import thunk from 'redux-thunk';
import { createGlobalReducer } from '@Reducers/global';
import { createMessageReducer } from '@Reducers/message';
import { createUserReducer } from '@Reducers/user';
import { CreateStoreParams } from './types';

function createAppStore(params: CreateStoreParams): Store {
  const { initialState, initialMiddleWare } = params;
  return reduxCreateStore(
    combineReducers({
      global: createGlobalReducer({
        initialState: initialState.global,
      }),
      message: createMessageReducer({
        initialState: initialState.message,
      }),
      user: createUserReducer({
        initialState: initialState.user,
      }),
    }),
    applyMiddleware(
      thunk.withExtraArgument({ ...initialMiddleWare }),
    ),
  );
}

export default createAppStore;
